---
title: Subresource Integrity
slug: Web/Security/Subresource_Integrity
tags:
  - HTML
  - HTTP
  - Intro
  - Networking
  - Security
---
<p><span class="seoSummary"><strong>Subresource Integrity</strong> (SRI) is a security feature that enables browsers to verify that resources they fetch (for example, from a <a href="/en-US/docs/Glossary/CDN">CDN</a>) are delivered without unexpected manipulation. It works by allowing you to provide a cryptographic hash that a fetched resource must match.</span></p>

<div class="note">
<p><strong>Note</strong>: For subresource-integrity verification of a resource served from an origin other than the document in which it’s embedded, browsers additionally check the resource using <a href="/en-US/docs/Web/HTTP/CORS">Cross-Origin Resource Sharing (CORS)</a>, to ensure the origin serving the resource allows it to be shared with the requesting origin.</p>
</div>

<h2 id="How_Subresource_Integrity_helps">How Subresource Integrity helps</h2>

<p>Using {{Glossary("CDN", "Content Delivery Networks (CDNs)")}} to host files such as scripts and stylesheets that are shared among multiple sites can improve site performance and conserve bandwidth. However, using CDNs also comes with a risk, in that if an attacker gains control of a CDN, the attacker can inject arbitrary malicious content into files on the CDN (or replace the files completely) and thus can also potentially attack all sites that fetch files from that CDN.</p>

<p>Subresource Integrity enables you to mitigate some risks of attacks such as this, by ensuring that the files your web application or web document fetches (from a CDN or anywhere) have been delivered without a third-party having injected any additional content into those files — and without any other changes of any kind at all having been made to those files.</p>

<h2 id="Using_Subresource_Integrity">Using Subresource Integrity</h2>

<p>You use the Subresource Integrity feature by specifying a base64-encoded cryptographic hash of a resource (file) you’re telling the browser to fetch, in the value of the <code>integrity</code> attribute of any {{HTMLElement("script")}} or {{HTMLElement("link")}} element.</p>

<p>An <code>integrity</code> value begins with at least one string, with each string including a prefix indicating a particular hash algorithm (currently the allowed prefixes are <code>sha256</code>, <code>sha384</code>, and <code>sha512</code>), followed by a dash, and ending with the actual base64-encoded hash.</p>

<div class="note">
<p><strong>Note</strong>: An <strong>integrity</strong> value may contain multiple hashes separated by whitespace. A resource will be loaded if it matches one of those hashes.</p>
</div>

<p>Example <code>integrity</code> string with base64-encoded sha384 hash:</p>

<pre>sha384-oqVuAfXRKap7fdgcCY5uykM6+R9GqQ8K/uxy9rx7HNQlGYl1kPzQho1wx4JwY8wC
</pre>

<p>So <code>oqVuAfXRKap7fdgcCY5uykM6+R9GqQ8K/uxy9rx7HNQlGYl1kPzQho1wx4JwY8wC</code> is the "hash" part, and the prefix <code>sha384</code> indicates that it's a sha384 hash.</p>

<div class="note">
<p><strong>Note</strong>: An <code>integrity</code> value's "hash" part is, strictly speaking, a <strong><em>cryptographic</em> <em>digest</em></strong> formed by applying a particular hash function to some input (for example, a script or stylesheet file). But it’s common to use the shorthand "hash" to mean <em>cryptographic</em> <em>digest</em>, so that's what's used in this article.</p>
</div>

<h3 id="Tools_for_generating_SRI_hashes">Tools for generating SRI hashes</h3>

<p>You can generate SRI hashes from the command-line with <strong>openssl</strong> using a command invocation such as this:</p>

<pre class="brush: bash">cat <strong>FILENAME.js</strong> | openssl dgst -sha384 -binary | openssl base64 -A</pre>

<p>or with <strong>shasum</strong> using a command invocation such as this:</p>

<pre class="brush: bash">shasum -b -a 384 <strong>FILENAME.js</strong> | awk '{ print $1 }' | xxd -r -p | base64
</pre>

<div class="note">
<p><strong>Notes</strong>:</p>

<ul>
	<li>The pipe-through-<code>xxd</code> step takes the hexadecimal output from <code>shasum</code> and converts it to binary.</li>
	<li>The pipe-through-<code>awk</code> step is necessary because <code>shasum</code> will pass the hashed filename in its output to <code>xxd</code>. That can have disastrous consequences if the filename happens to have valid hex characters in it — because <code>xxd</code> will also decode that and pass it to <code>base64</code>.</li>
</ul>
</div>

<p>Additionally, the <strong>SRI Hash Generator</strong> at <a href="https://www.srihash.org/">https://www.srihash.org/</a> is an online tool you can use to generate SRI hashes.</p>

<h3 id="Cross-Origin_Resource_Sharing_and_Subresource_Integrity">Cross-Origin Resource Sharing and Subresource Integrity</h3>

<p>For subresource-integrity verification of a resource served from an origin other than the document in which it's embedded, browsers additionally check the resource using <a href="/en-US/docs/Web/HTTP/CORS">Cross-Origin Resource Sharing (CORS)</a>, to ensure the origin serving the resource allows it to be shared with the requesting origin. Therefore, the resource must be served with an <code><a href="/en-US/docs/Web/HTTP/Headers/Access-Control-Allow-Origin">Access-Control-Allow-Origin</a></code> header that allows the resource to be shared with the requesting origin; for example:</p>

<pre>Access-Control-Allow-Origin: *</pre>

<h2 id="Examples">Examples</h2>

<p>In the following examples, assume that <code id="sriSnippet">oqVuAfXRKap7fdgcCY5uykM6+R9GqQ8K/uxy9rx7HNQlGYl1kPzQho1wx4JwY8wC</code> is already known to be the expected SHA-384 hash (digest) of a particular script <code>example-framework.js</code>, and there’s a copy of the script hosted at <code>https://example.com/example-framework.js</code>.</p>

<h3 id="Subresource_Integrity_with_the_&lt;script&gt;_element">Subresource Integrity with the &lt;script&gt; element</h3>

<p>You can use the following {{HTMLElement("script")}} element to tell a browser that before executing the <code>https://example.com/example-framework.js</code> script, the browser must first compare the script to the expected hash, and verify that there's a match.</p>

<pre class="brush: html">&lt;script src="https://example.com/example-framework.js"
        integrity="sha384-oqVuAfXRKap7fdgcCY5uykM6+R9GqQ8K/uxy9rx7HNQlGYl1kPzQho1wx4JwY8wC"
        crossorigin="anonymous"&gt;&lt;/script&gt;</pre>

<div class="note">
<p><strong>Note</strong>: For more details on the purpose of the <code>crossorigin</code> attribute, see <a href="/en-US/docs/Web/HTML/CORS_settings_attributes">CORS settings attributes</a>.</p>
</div>

<h2 id="How_browsers_handle_Subresource_Integrity">How browsers handle Subresource Integrity</h2>

<p>Browsers handle SRI by doing the following:</p>

<ol>
	<li>
	<p>When a browser encounters a {{HTMLElement("script")}} or {{HTMLElement("link")}} element with an <code>integrity</code> attribute, before executing the script or before applying any stylesheet specified by the {{HTMLElement("link")}} element, the browser must first compare the script or stylesheet to the expected hash given in the <code>integrity</code> value.</p>

	<p class="note"><strong>Note</strong>: For subresource-integrity verification of a resource served from an origin other than the document in which it’s embedded, browsers additionally check the resource using <a href="/en-US/docs/Web/HTTP/CORS">Cross-Origin Resource Sharing (CORS)</a>, to ensure the origin serving the resource allows it to be shared with the requesting origin.</p>
	</li>
	<li>If the script or stylesheet doesn’t match its associated <code>integrity</code> value, the browser must refuse to execute the script or apply the stylesheet, and must instead return a network error indicating that fetching of that script or stylesheet failed.</li>
</ol>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('Subresource Integrity')}}</td>
			<td>{{Spec2('Subresource Integrity')}}</td>
			<td></td>
		</tr>
		<tr>
			<td>{{SpecName('Fetch')}}</td>
			<td>{{Spec2('Fetch')}}</td>
			<td></td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="&lt;script_integrity&gt;">&lt;script integrity&gt;</h3>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("html.elements.script.integrity")}}</p>

<h3 id="CSP_require-sri-for">CSP: require-sri-for</h3>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.csp.require-sri-for")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li>Content Security Policy</li>
	<li>{{httpheader("Content-Security-Policy")}}</li>
	<li><a href="https://frederik-braun.com/using-subresource-integrity.html" id="page-title">A CDN that can not XSS you: Using Subresource Integrity</a></li>
	<li><a href="https://w3c-test.org/subresource-integrity/subresource-integrity.html" id="w3c-test">Subresource Integrity test from W3C</a></li>
	<li><a href="https://www.srihash.org/">SRI Hash Generator</a></li>
</ul>

<p>{{QuickLinksWithSubpages("/en-US/docs/Web/Security")}}</p>
